import os, sys, random
import pygame
from pygame.locals import *

class Particle:
    def __init__(self):
        self.speed = random.randint(1,8)
        self.xpos = 1.00
        self.ypos = 1.00
        self.x = random.randint(0,640)
        self.y = random.randint(0,480)
        self.xpos = self.x
        self.ypos = self.y
    
    def move(self, dt):
        self.xpos -= dt * (self.speed * 3) * 0.005
        self.ypos += dt * (self.speed * 3) * 0.005
        if self.xpos > 640: self.xpos -= 640
        if self.xpos < 0: self.xpos += 640
        if self.ypos > 480: self.ypos -= 480
        if self.ypos < 0: self.ypos += 480
        
        self.x = self.xpos
        self.y = self.ypos
        
class Menu:
    def __init__(self):
        self.bgimage = pygame.image.load(os.path.join('data', 'title.png')).convert_alpha()
        #self.selectimage = pygame.image.load(os.path.join('data', 'select.png')).convert_alpha()
        #self.movesound = pygame.mixer.Sound(os.path.join('data', 'menu.ogg'))
        #self.selsound = pygame.mixer.Sound(os.path.join('data', 'menuselect.ogg'))
        self.planetimage = pygame.image.load(os.path.join('data', 'planet-menu.png')).convert_alpha()
        self.starsimage = pygame.image.load(os.path.join('data', 'stars.png')).convert_alpha()
        pygame.mixer.music.load(os.path.join('data', 'song1.ogg'))
        self.LastTicks = pygame.time.get_ticks()
        self.particles = []
        for part in range(0,30):
            self.particles.append(Particle())
        self.selection = 1
        self.movingup = True
        
    def Thinky(self, dt):
        for part in self.particles:
            part.move(dt)
            
    def DrawScene(self, screen):
    
        screen.fill((0,0,0))
        
        for part in self.particles:
            screen.blit(self.starsimage, (part.x, part.y), (32 * ((part.speed - 1) % 4), 0, 32, 32))
        screen.blit(self.planetimage, (0,0))
        screen.blit(self.bgimage, (0,0))
        
        #selectloc = (356,233 + (self.selection * 48))
        #screen.blit(self.selectimage, selectloc)
           
    def PickIt(self, screen):
        #FANCY FADE OUT!
        # for x in range(50):
            # temp = x
            # x = 50 - x
            # screen.fill((0,0,0))
            # work = self.bgimage
            # work.set_alpha((x * 255) / 50.0, RLEACCEL)
            # screen.blit(work, (0,0))
            # pygame.display.flip()
            # pygame.time.wait(10)
        
        return self.selection
        
    # def MoveDown(self, screen):
        # if self.selection == 3:
            # return
        # self.movesound.play()
        # temploc = 233 + (self.selection * 48)
        # yvel = 0
        # self.selection += 1
        # while (temploc < (233 + (self.selection * 48))):
            # yvel += 1
            # screen.blit(self.bgimage, (0,0))
            # temploc += yvel
            # selectloc = (356,temploc)
            # screen.blit(self.selectimage, selectloc)
            # pygame.display.flip()
            # pygame.time.wait(15)
        
            
    # def MoveUp(self, screen):
        # if self.selection == 0:
            # return
        # self.movesound.play()
        # temploc = 233 + (self.selection * 48)
        # yvel = 0
        # self.selection -= 1
        # while (temploc > (233 + (self.selection * 48))):
            # yvel += 1
            # screen.blit(self.bgimage, (0,0))
            # temploc -= yvel
            # selectloc = (356,temploc)
            # screen.blit(self.selectimage, selectloc)
            # pygame.display.flip()
            # pygame.time.wait(15)
        
            
    def ShowMenu(self, screen):
        #screen.fill((0,0,0))
        pygame.mixer.stop
        
        pygame.mixer.music.play(-1)
        
        #FANCY FADE IN OMG
        # for x in range(40):
            # screen.fill((0,0,0))
            # work = self.bgimage
            # work.set_alpha((x * 255) / 40.0, RLEACCEL)
            # screen.blit(work, (0,0))
            # pygame.display.flip()
            # pygame.time.wait(5)
        
        while 1:
            self.thetime = pygame.time.get_ticks()
            self.dt = self.thetime - self.LastTicks
            self.LastTicks = self.thetime
        
            for event in pygame.event.get():
                if event.type == pygame.QUIT: 
                    sys.exit()
                elif event.type == KEYDOWN:
                    
                    if (event.key == K_ESCAPE):
                        self.selection = 3
                        return self.PickIt(screen)
                elif event.type == MOUSEBUTTONUP:
                        #self.selsound.play()
                    return self.PickIt(screen)
                        
            self.Thinky(self.dt)
            self.DrawScene(screen)
            
            pygame.display.flip()
            pygame.time.wait(25) #
                    
        