

import pygame, os, sys, optparse
from pygame.locals import *
from menu import *
from game import *

USAGE = """%prog [-fn]"""
systemVersion = "0.0.1"
VERSION = "%prog v" + systemVersion

def parse_options():

    parser = optparse.OptionParser(usage=USAGE, version=VERSION)

    parser.add_option("-f", "--fullscreen",
            action="store_true", default=False, dest="fullscreen",
            help="enable fullscreen mode")
    
    opts, args = parser.parse_args()
    return opts, args

def ShowScreen(screen, pagename):
    
    img = pygame.image.load(os.path.join('data', '%s.png' % (pagename))).convert()
    screen.fill((0,0,0))
    screen.blit(img, (0,0))
    pygame.display.flip()

    while 1:
        for event in pygame.event.get():
            if event.type == pygame.QUIT: 
                sys.exit()
            elif event.type == KEYDOWN:
                return
            elif event.type == MOUSEBUTTONUP:
                return
        
        pygame.time.wait(50)
                
        

def main(fullscreen):

    try:
            import psyco
            psyco.background()
            print 'psyco found and enabled!'
    except ImportError:
            print 'psyco not found! don\'t worry, this game doesn\'t really need it.'
    
    pygame.mixer.pre_init(22050, -16, 1, 2048)
    pygame.init()
    
    size = width, height = 640, 480
    if fullscreen:
        screen = pygame.display.set_mode(size, FULLSCREEN)
        pygame.time.wait(1000)#wait for the computer to switch video modes
    else:
        screen = pygame.display.set_mode(size, HWSURFACE|DOUBLEBUF)
    
    pygame.display.set_caption('Space Reactions - by fydo for Ludum Dare 10')

    #intro time!
    #theIntro = Intro()
    #theIntro.DisplayIntro(screen, nosound)
    
    while 1:
        screen.fill( (0, 0, 0)) 
        pygame.mixer.stop
        
        # Purge input queue
        pygame.event.get()
        
        # Do introscreen stuff  here
        themenu = Menu()
        
        pygame.mouse.set_visible(1)
        result = themenu.ShowMenu(screen)
        if result == 0:
            pass
            #theinst = Inst()
            #theinst.DisplayInst(screen)
        elif result == 1:
            pygame.mixer.music.stop
            pygame.mixer.music.load(os.path.join('data', 'song2.ogg'))
            pygame.mixer.music.play(-1)
            ShowScreen(screen, 'howto')
            thegame = Game()
            result = thegame.Go(screen)
            pygame.mixer.music.stop
            
            if result == 1: #won
                pygame.mixer.music.load(os.path.join('data', 'win.ogg'))
                pygame.mixer.music.play(0)
                ShowScreen(screen, 'win')
            elif result == -1: #lost
                pygame.mixer.music.load(os.path.join('data', 'lose.ogg'))
                pygame.mixer.music.play(0)
                ShowScreen(screen, 'lose')
                
        elif result == 2: 
            pass
        elif result == 3:
            pygame.display.quit()
            return 
        
def Start():
    # Welcome the player
    print 'fydo\'s LD10 game - http://www.fydo.net'
    
    #Parse the options up! Woo
    opts, args = parse_options()
    
    # Play time
    main(opts.fullscreen)
    
    # Say goodbye like every good little program should
    print 'thanks for playing!'
        
        
if __name__ == '__main__':
    Start()

